﻿using System;

namespace CommonTools.Attributes
{
	/// <summary>
	/// Описание класса из базы данных, его назначение
	/// </summary>
	[AttributeUsage(AttributeTargets.Class, AllowMultiple = true)]
	public class EntityDescriptionAttribute : Attribute
	{
		/// <summary>
		/// Название сущности, которую описывает класс
		/// </summary>
		public string EntityName { get; set; }

		/// <summary>
		/// Описание назначения сущности
		/// </summary>
		public string Description { get; set; }

		/// <summary>
		/// Конструктор
		/// </summary>
		/// <param name="entityName">Название сущности, которую описывает класс</param>
		/// <param name="description">Описание назначения сущности</param>
		public EntityDescriptionAttribute(string entityName, string description)
        {
			EntityName = entityName;
			Description = description;
        }
    }
}