﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Security
{
	/// <summary>
	/// Связка пользователь - роль
	/// </summary>
	[DataContract]
    [EntityDescription("UserRole", "Связь пользователей системы с ролями, которые им назначены")]
    [EntityDependency("Role", "RoleId", "К какой роли относится пользователь")]
    [EntityDependency("User", "UserId", "К какой роли относится пользователь")]
    public class UserRole : BaseEntity, IEntitySecurityExtenstion<UserRole>
    {
        [DataMember]
        [MapConfiguration("RoleId")]
        public Guid RoleId { get; set; }

        [DataMember]
        [MapConfiguration("UserId")]
        public Guid UserId { get; set; }

        //-------------------------------------------------------------------------

        public virtual Role Role { get; set; }

        public virtual User User { get; set; }

        public UserRole SecurityCheck(UserRole entity, bool allowFullData) => entity;

		//-------------------------------------------------------------------------
	}
}