﻿using DesktopTools.Controls;
using DesktopTools.Enums;
using DesktopTools.Interfaces;
using DesktopTools.Models;
using ModuleTools.Enums;
using SecurityBusinessLogic.BindingModels;
using SecurityBusinessLogic.BusinessLogics;
using SecurityBusinessLogic.ViewModels;
using System;
using System.Collections.Generic;

namespace SecurityWindowsDesktop.EntityControls
{
	/// <summary>
	/// Реализация контрола для списка ролей
	/// </summary>
	public partial class ControlRoleList : 
		GenericControlEntityList<RoleGetBindingModel, RoleSetBindingModel, RoleListViewModel, RoleViewModel, RoleBusinessLogic>,
		IGenericControlEntityList<RoleListViewModel, RoleViewModel>
	{
		public ControlRoleList() : base()
		{
			InitializeComponent();
			Title = "Роли";
			ControlId = new Guid("6a33ce5c-e950-4294-9f75-2a0b35941bf7");
			AccessOperation = AccessOperation.Роли;
			ControlViewEntityElement = new ControlRoleElement();
			_genericControlViewEntityList = this;
		}

		public IControl GetInstanceGenericControl() => new ControlRoleList() { ControlId = Guid.NewGuid() };

		public ControlViewEntityListConfiguration GetConfigControl() => new()
		{
			PaginationOn = false,
			HideToolStripButton = new List<ToolStripButtonListNames>
			{
				ToolStripButtonListNames.toolStripButtonSearch
			}
		};

		public RoleListViewModel GetDataForControl() => _businessLogic.GetList(new RoleGetBindingModel());

		public RoleListViewModel GetDataFromParentForControl(Guid id) => throw new NotImplementedException();

		public RoleListViewModel GetDataWithPageNameForControl(string key) => throw new NotImplementedException();

		public RoleListViewModel GetDataWithPageNumberForControl(int page, int count) => throw new NotImplementedException();
	}
}