﻿using DesktopTools.Controls;
using DesktopTools.Enums;
using DesktopTools.Interfaces;
using DesktopTools.Models;
using ModuleTools.Enums;
using SecurityBusinessLogic.BindingModels;
using SecurityBusinessLogic.BusinessLogics;
using SecurityBusinessLogic.ViewModels;
using System;
using System.Collections.Generic;

namespace SecurityWindowsDesktop.EntityControls
{
	/// <summary>
	/// Реализация контрола для списка пользователей роли
	/// </summary>
	public partial class ControlRoleUserList : 
		GenericControlEntityList<UserRoleGetBindingModel, UserRoleSetBindingModel, UserRoleListViewModel, UserRoleViewModel, UserRoleBusinessLogic>,
		IGenericControlEntityList<UserRoleListViewModel, UserRoleViewModel>
	{
		public ControlRoleUserList()
		{
			InitializeComponent();
			Title = "Связи пользователей с ролями";
			ControlId = new Guid("c5748925-c8ec-4d06-a256-c72b0983d332");
			AccessOperation = AccessOperation.ПользователиРоли;
			ControlViewEntityElement = new ControlUserRoleElement();
			_genericControlViewEntityList = this;
		}

		public IControl GetInstanceGenericControl() => new ControlRoleUserList() { ControlId = Guid.NewGuid() };

		public ControlViewEntityListConfiguration GetConfigControl() => new()
		{
			PaginationOn = false,
			HideToolStripButton = new List<ToolStripButtonListNames>
			{
				ToolStripButtonListNames.toolStripButtonUpd,
				ToolStripButtonListNames.toolStripButtonSearch
			}
		};

		public UserRoleListViewModel GetDataForControl() => throw new NotImplementedException();

		public UserRoleListViewModel GetDataFromParentForControl(Guid id) => _businessLogic.GetList(new UserRoleGetBindingModel { RoleId = id });

		public UserRoleListViewModel GetDataWithPageNameForControl(string key) => throw new NotImplementedException();

		public UserRoleListViewModel GetDataWithPageNumberForControl(int page, int count) => throw new NotImplementedException();
	}
}